unit uversiones;

interface
const
CONDITIONAL_DEFINES =''
 + {$IFDEF COSTOSHIDROPOSITIVOS}'+'{$ELSE}'-'{$ENDIF}+'COSTOSHIDROPOSITIVOS'#13#10
 + {$IFDEF PDE_RIESGO}'+'{$ELSE}'-'{$ENDIF}+'PDE_RIESGO'#13#10
 + {$IFDEF MONITORES}'+'{$ELSE}'-'{$ENDIF}+'MONITORES'#13#10
 + {$IFDEF CALC_DEMANDA_NETA}'+'{$ELSE}'-'{$ENDIF}+'CALC_DEMANDA_NETA'#13#10
 + {$IFDEF MODOGRAFICO}'+'{$ELSE}'-'{$ENDIF}+'MODOGRAFICO'#13#10
 + {$IFDEF DEBUG_MULTI_HILO}'+'{$ELSE}'-'{$ENDIF}+'DEBUG_MULTI_HILO'#13#10
 + {$IFDEF DBG_HIDRO_CON_EMBALSE}'+'{$ELSE}'-'{$ENDIF}+'DBG_HIDRO_CON_EMBALSE'#13#10
 ;


const
// _134_Rienda
// _133_Bozal
// _130_Rebenque
// _129_Sobeo

  vSimSEESimulador_= '_128_Tia';
  // rch 201603090654  bugfix en Fuentes Reales asociadas al Actor PVSolar
  // El bug fue introducido el 14/2 al introducir en globs de SimSEE la variable
  // HUSOHorario y por tanto afecta los resultados de corridas que tuvieran el Actor Solar PV
  // realizadas con binarios compilados con posterioridad a dicha fecha (versiones 128_Prima y 128_PrimaPrima)

//  vSimSEESimulador_= '_128_PrimaPrima';
  // rch&fb 201603041231  bugfix en Editor de FUentes CEGH. No permita cambiar el pronstico.

  //vSimSEESimulador_= '_128_Prima';
  // rch 20160216 cambio en sorteo de fuentes CEGH para que si tiene un solo escenario NO sorte escenario
  // y as no afecte los sorteos de los Ruidos Blancos Gaussianos (RBG). EN futura versin esto se soluciona
  // con dos fuentes independientes de sorteso, una para los escenarios y otra para los RBG.
  // Tambin se agreg un CheckBox "Modo ComparaciN" en la Operacin Crnica
  // SumaDobleProductoConDurPosTopeado si el checkbox= false hace lo mismo que ahora si
  // est a true lo que hace es poner en el resutado el producto con durpos cuando el marginal est por
  // debajo del tope en el resultado y en el recorte cuando est para arriba. Esto tiene utilidad para
  // determinar la energa entregada por un generador por debajo y por encima de un determinado valor
  // por ejemplo para determinar la energa entregada en situacin de excedentes de costo variable nulo poniendo
  // el umbral por encima del precio de la exportacin "sumidero" de excedentes.


//   vSimSEESimulador_= '_128_Estribo';
  // rch 20151211 cambios en uPrint.pas bugfix en definicin de tipos de series en los grficos.

//  vSimSEESimulador_ =  '_127_Cabresto';
// rch 20151204 cambios en uescala.pas para mejorar clculo de escalas automticas para graificas SimRes3

//  vSimSEESimulador_ =  '_126_Sobre-Cincha';
  // rch@201511080726 cambios en el editor para serpar la MIGRACION_PERSISTENCIA
  // del editor que est en produccin por problemas para Exportar fichas contantes
  // a Excel.
  // Agrego posibilidad de condicionar la disponibilidad de un Arco al valor
  // de una fuente.

//   vSimSEESimulador_ =  '_125_Badana';
 // rch@201510201014 hago cambio en ucmdoptsim para que funcione la definicin de
 // un directori temporal de corridas diferente del de la sala. Esto puede traer problemas
 // en archivos que no tengan la ruta completa. En el caso de los archivos de DemandaDetallada
 // se solucion, pero pueden quedar otros. Este cmabio no afecta el SimSEESimulador
 // solo afecta a los de lnea de comando

//  vSimSEESimulador_ =  '_124_Pelego';
  // rch@20151001
  // BUGFIX IMPORTANTE. Haba un error "desde el origen del SimSEE" que haca que
  // el actualizador de fichas de parmetros dinmicos "no viera" la ficha que le
  // quedara en la posicin 0 (Cero).
  // Esto tiene consecuencias o no dependiendo de la suerte que hubiera tenido en que
  // la primer ficha dinmica fuera relevante o no. Este bug afectaba solamente la OPTIMIZACION.
  // El lugar de las fichas LPD depende del resto de las fichas y del orden de insersin de los
  // Actores. Esto llevaba a comportamientos extraos como que por agregar una ficha en un actor
  // cambiaba el comportamiento de otro, por sustituirlo en el casillero "no visto".


// vSimSEESimulador_ = '_123_Cincha';
// Se agrega control en la resolucin de bornes de las fuentes para que NO permita la ejecucin
// si hay bornes sin resolver. Esto es para prevenir errores del editor. (O de la edicin manual de salas).

 //  vSimSEESimulador_ = '_122_Basto';
 // Incorpora cambios de Felipe sobre la hidro con embalse binacional.(todava beta)

//  vSimSEESimulador_ = '_121_Carona';
  // rch@20150901 BUGFIX IMPORTANTE: En la optimizacin MULTIHILO haba un error
  // de diseo por el cul si se corran ms de una Optimizacin MultiHilo en simultneo
  // en la misma mquina los procesos se interferan. El error vena por los Eventos
  // creados en la unidad umh_sincrodata que tena nombre que no identificaba el
  // proceso en forma nica con lo cual los Workers de una optimizacin sealizaban
  // tarea entregada en todas las lanzadas en forma simultnea. El error no afecta los
  // resultados de las optimizaciones Multihilo si se ejecutaba una sola.

//  vSimSEESimulador_ = '_120_Jerga_';
  // Asociada al cambio de VERSION_ArchiTexto = 133; // df,fb@201508241122
  // Se le agrega al actor THidroConEmbalse la posibilidad de introducirle error
  // a la cota inicial.
  // Adems se mejora acceso a Excel de SimRes3 tratando de mejorar la compatibilidad
  // con el Excel nuevo.

//  vSimSEESimulador_ = '_119_Amargo_'; // rch@201506291547
  // agrego DEFINE ExpansionRuida al Editor para que funcione TFuenteSelectorHorario
  // este parche es para que funcione, pero hay que cambiar la fuente para que guarde el nombre
  // del borne en lugar del idBorne para independizar la referencia del borne de la definicin de
  // la bornera de las fuentes.

  //vSimSEESimulador_ = '_118_MateAmargo_'; // fb@201506241651
  //  en usaladejuegos->simular, se cambia el orden de Preparar_fuentes_ps para
  // antes de ActualizarEstadoGlobal(true) de Actores y Fuentes.
  // El cambio fue realizado para que HidoConEmbalse pueda leer el valor de la
  // fuente de Aportes en ActualizarEstadoGlobal(true)

  //vSimSEESimulador_ = '_117_Carqueja_'; // rch@201506190107
  //  Vuelvo a mtodo Referencia definido por defecto en TFuenteAleatoria.


//  vSimSEESimulador_ = '_116_Carqueja_'; // rch&fb@201506172111
// bugfix: La fuente "MaxMin" no sebreescriba el mtodo "referencia" con lo cual
// no se estaba ordenando bien la dependencia de fuentes. Esto ocasionaba diferencias
// entre las corridas monohilo y multihilo.

//  vSimSEESimulador_ = '_115_Carqueja_'; // rch&fb@201506121010
//  bugfix: THidroConEmbalse. Tal como estaba inicializaba mal h_real en el clculo
// de las prdidas de Filtracin y Evaporacin durante la optimizacin. Esto llevaba
// a que se calcularan en base a la resolucin de la estrella anterior. Esto puede explicar
// las diferencias detectadas entre la optimizacin Multi-hilo y mono-hilo, dado que "la
// estrella anterior" cambia mucho al tener varios hilos. Las consecuencias sobre los resultados
// deben no ser muy grandes pues la filtracin y la evaporacin no son siempre volmenes pequeos.


///  vSimSEESimulador_ = '_114_Carqueja_'; // rch@201506112022
// Bugfix en Editor de FuenteSelectorHorario Impeda editar una fuente
// previamente guardada.


//  vSimSEESimulador_ = '_113_Carqueja_'; // rch@201506011153
// BUGFIX. en el editor de TDemandaDetallada, exportaba mal a Excel si se trataba
// de un archivo binario de demanda que ya exista (o sea que no se creaba). El
// error se produce si el archivo tiene fecha de inicio diferente que la de la sala.

//  vSimSEESimulador_ = '_112_DeNoSi_'; // rch@201505261328
  // recompilo volviendo el clculo del valor del agua a DERIVADAS NO SIMETRICAS.


//  vSimSEESimulador_ = '_111_Carqueja_'; // rch@20150518
// BUGFIX. Se arregla error introducido por DFusco en uaxiliares.pas que implicaba
// la mezcla de formatos entre ISO y locales durante la lectura de una sala.
// Se debe mantener el criterio de que TODA INFO guardad est en formato ISO.


//  vSimSEESimulador_ = '_110_Carqueja_'; // rch@20150514
// Se arregla variable agregada pro Felipe para fijar el valor del agua en
// modalidad control de cota de las hidrulicas.
// Se recompila para habilitar Excel.

//  vSimSEESimulador_ = '_109_Carqueja_'; // rch@201505130635
// versin experimental NO USA EXCEL
  // + Bugfix en inicializacin de CF si engancha con otro CF y no est CAR  activa
  // intentaba inicializar histogramas que no haba creado.
  // Este bug se introdujo en una versin reciente al "experimentar" con la CAR.
  // + Se agrega a los editores de GTer_Basico y DemandaDetallada el manejo
  // de la reserva rotante. Se agrega en el panel de Sim/Opt del editor
  // un checkbox para habilitar el manejo de ReservaRotante (todava en desarrollo).
  // + Se corrige align Panel de escenarios para que se vean todos.
  // + Se corrigen textos en panel de control de cota de THidroConEmbalse
//
//  vSimSEESimulador_ = '_108_Carqueja_'; // rch@201505042100
// Bugfix. en archivo SimCostos estaba imprimiendo mal el VaR(0.05)
// Tambin se agreg checkbox al editor para poder marcar si se desea o no
// que se impriman los  archivos con estado de fin de crnica que son muchos
// y generalmente no se utilizan.
//

//  vSimSEESimulador_ = '_107_Garufa_'; // rch@201504240826
// modifico el control de cotas de las THidroConEmbalse para que pueda
// activarse en Simulacin y en Optimizacin por separado. Antes de esta
// versin cuando se activaba operaba solamente durante la Simulacin.
// Para agregarlo durante la optimizacin y que tenga sentido la funcin
// CF(X,k) debe incluir el costo de la penalidad incurrido como un costo
// verdadero sino el optimizador termina compensando el control.


//  vSimSEESimulador_ = '_106_Garufa_'; // rch@201504222043
  // Se mejora optimizacin con aversin al riesgo cambiando el re-muestreo
  // de los histogramas de costo para conservar siempre el peor y mejor valor
  // entre las muestras.


//  vSimSEESimulador_ = '_105c_Corral_'; // rch@201503270902
  // Agrego restriccin de caudal medio mximo por paso de tiempo
  // en TFichaSuministroSimpleCombustible


  // vSimSEESimulador_ = '_105c_Tranquera_'; // rch@2015031628
  // Recompilacin para propuesta de versin oficial.

  // vSimSEESimulador_ = '_105c_Laud_'; // rch@201503101743
  // Agreto que las Hidro de pasada publiquen la variable dual de la
  // restriccin de balance (V_Turbinado+V_Vertido - V_Aportes = 0 ) en USD/Hm3

  // vSimSEESimulador_ = '_105c_Asinos_'; // rch@201502261954
  // Se mejora forma en que los Generadores Postizadores leen las fuentes
  // se contina debuggeando al versin Diezminutal.

  // vSimSEESimulador_ = '_105c_Bagual_'; // rch@20150222227
  // Se agregan parmetros a TPronostico y TFuenteSintetizador para poder
  // hacer consultas de pronsticos.
  // Cambia el comportamiento de TEdit en VisorTablas para que al pegar
  // desde Excel cambie retornos de lneas por ";" y tambin Tabuladores por ";"
  // Eso permite por ejemplo copiar una lista de valores desde Excel directamente
  // en el casillero de la GUIA de un cono de pronsticos en una fuente CEGH.

  // vSimSEESimulador_ = '_105c_Arisco_'; // rch@201502132347
  // bugfix - THidroConembalse estaba calculando mal la derivada del costo futuro
  // en el nivel ms bajo de la discretizacin lo que haca que se sub-valorara
  // el agua en el fondo del los lagos.

  //vSimSEESimulador_ = '_105c_Chcaro_'; // rch@201502090757
  //  bugfix en el interpolador de demanda detallada horaria para salas diezminutales
  //  acondiciono mecanismo postizador en base a Demanda Neta para que funcione
  //  en salas Diezminutales. Tal como estaba asuma paso de tiempo >= 1h.
  //  Se agrega publicacin por defecto para SimRes3 del valor dual de la
  //  restriccin de caudal de las hidrulicas de pasa

//  vSimSEESimulador_ = '_105c_Argot_'; // rch@201502041222
  // Se cambi la forma de tratar las series histricas en los sitntetizadores CEGH para
  // permitir que se puedan usar series histricas con diferente paso entre muestras que el
  // paso de simulacin.

  //  vSimSEESimulador_ = '_TEST105_daa'; // rch@201501310840
    // Se supone que no tiene cambios de algoritmos y que solo se agerg
    // la capacidad de los objetos persistentes de describir sus campos para
    // faliciltar la edicin de las salas. Pero se cambiaron muchos archivos con
    // lo cual se est en MODO TEST.

//  vSimSEESimulador_ = '_ADME105_daa'; // rch@201501241030
  // agrego PostOper Monotonizar para facilitar la comparacin entre
  // salidas de salas horarias y de salas de paso de tiempo mayor con postes (semanal, diaria, etc.).
  // Adems cambi la forma en que el Esclavizador sub-muestreado sortea en caso de
  // que se no se marque "resumir promediando" ahora usa su propia fuente aleatoria y as
  // no perturaba los sorteos de la esclava. Esto tambin es para facilitar la comparacin
  // de simulacin crnicas horarias vs. semanales.


//  vSimSEESimulador_ = '_ADME_1.05da'; // rch@201501222154
// Agrego CONDITIONAL DEFINES en uEsclavizaroSubMuestreado y en uFuenteSintetizador para facilitar debug de sorteos en fuentes sub-muestreadas.
// bugfix en funciones de getEstado y setEstado de los sorteadores uniformes esto podra mejorar la repetitibilidad de las optimizaciones multi-hilo.
// bugfix en calculo de fecha del fin de paso. Esto puede afectar el funcionamiento de los CONTRATOS EN MODALIDAD DEVOLUCION.

  // vSimSEESimulador_ = '_ADME_1.05d'; // rch@201501221946
  // modifico comportamiento de TPostOper_acumularConPisoYTecho
  // para que adems de calcular la evolucin del acumulado con piso y techo
  // recorte el IngresoNeto cuando actuan el piso o el techo.

  //  vSimSEESimulador_ = '_ADME_1.05c'; // rch@201501051531
  // Se mejora modelo de Hidro con Embalse para cubrir la condicin en que
  // iniciando el paso de tiempo en cotas por debajo de las operativas de las
  // turbinas y del vertedero (esto es no puede evacuar agua) el aporte del paso
  // es de tal magnitud que necesita de evaacucin para control de crecida.
  // Lo que se hizo fue cambiar el modelo de hidro para estimar los caudales
  // la capacidad de turbinar y de verter en base al volumen final del paso sin Erogado.

//  vSimSEESimulador_ = '_ADME_1.05b'; // rch@201412091917
  // Bugfix. En TFuenteSelector_Horario. Haba un bug que impeda la ejecucin
  // de las salas con este tipo de fuente.
  // Se agrega Print en SimRes3 para soporte de Sripts R

  // vSimSEESimulador_ = '_ADME_1.05'; // rch@201411251123
  // cambio la PostOper cambioPasoDeTiempo para que funcione
  // tambin si el el cambio es reduciendo el paso. Tal como estaba
  // solo funcionaba bien si se aumentaba el paso.


//  vSimSEESimulador_ = '_ADME_1.04'; // rch@201411161131
  // Agrego postOpers CVaR, CrearConstante, AcumularConPisoYTecho todas
  // ellas para facilitar el clculo del Fondo de Estabilizacin de Energa.
  // Tambin modifico las PosOpers para que sepa como operar con CronVars
  // que sean mono_cronicas o mono_paso.

//  vSimSEESimulador_ = '_ADME_1.03'; // rch@201411080527
  // Bugfix corrijo bug introducido un usalasdejuego en la 1.02 por el cual
  // la fucion de CostoFuturo quedaba NULA salvo para el penltimo
  // frame temporal.

//  vSimSEESimulador_ = '_ADME_1.02'; // rch@201410271633
  // 1) bugfix en los actores Solar y Elico la opcin "restar para postizar"
  // aplicaba siempre sin importar si el casillero estaba marcado o no.
  // 2) Se agreg en SimRes la posoperacin CVaR para facilitar clculo
  // de parmetros para el Fondo de Estabilizacin de la Energa.

//  vSimSEESimulador_ = '_ADME_1.01'; // rch@201410030705
  // 1) se agrega opcin de imprimir solamentFe variables usadas en
  // Plantillas SimRes3.
  // 2) agrega factores de indexacin en Bioembalse
  // 3) SimRes3 Si solo se usan PrintCronVars que no usan Excel no intenta
  // abrir el libro Excel. Esto hace que no sea necesario tener Excel instalado
  // si solo se usan por hitograma_txt como princronvar

//  vSimSEESimulador_ = '_ADME_1.0'; // rch@201409161942

//  vSimSEESimulador = '4.56_regas_prebeta'; // rch@201408262148

//  vSimSEESimulador = '4.55_statera_frictio_'; // rch@201408231804
  // varios cambios en actores asociados a la red de combustibles.

//  vSimSEESimulador = '4.54_statera_frictio_'; // rch@201408182114
  // bugfix. error introducido en la 4.53 impedia cargar salas con
  // algunso cegh; dando error al cargar.

//  vSimSEESimulador = '4.53_statera_frictio_'; // rch@201408101836
  // agrego posibilidad de especificar On/Off por paso en la TV
  // del TGer_Combinado.


//  vSimSEESimulador = '4.52_statera_frictio_'; // rch@201408041721
  // se corrige problema de salvado de fuente de ndice en bioembalse

//  vSimSEESimulador = '4.51_statera_frictio_'; // rch@201408021915
  // agrego operacin crnica promedioPonderadoConDurPos

//  vSimSEESimulador = '4.50_statera_frictio_'; // rch@201407300123
  // correccin de texto de etiqueta en formulario de edicin de Parque Elico

  //vSimSEESimulador = '4.49_statera_frictio_';
  //rch@201407272310 bugfix. En el editor de fichas de CicloCombinado
  // estaban invertidas las etiquetas de los casilleros de PagoPorPotencia
  // y pago por energa.

 // vSimSEESimulador = '4.48_statera_frictio_';
  // rch@201407261041 Agrego facilidad para clculo de GradienteDeInversion
  // en los GENERADORES.

//  vSimSEESimulador = '4.47_statera_frictio_';
// rch@201407221423 Bugfix en modelo de CicloCombinado.
// haba error en el cargado de la matriz del Paso. Este error afecta
// cualquier sala que estuviera usando esta central.


//  vSimSEESimulador = '4.46_statera_frictio_';
//rch@201407201911 Agrego cv_NoCombustible en generadores trmicos.

//  vSimSEESimulador = '4.45_fatum_statera_';
  // bugfix ... en en actor solar PV. Corrigo error introducido al netear
  // con la demanda.

//  vSimSEESimulador = '4.44_fatum_statera_';
  // rch20140714 mejoro interpolacin en transformadores CEGH.

//  vSimSEESimulador = '4.43_fatum_statera';
  // rch@20140705 comienzo a implementar la opcin de POSTIZAR en base a
  // una demanda NETA en lugar de por una demanada principal.

//  vSimSEESimulador = '4.42_fatum_';
//  201407031509 BUGFIX. En clculo de CostoDirectoDelPaso en ugter_basico_PyCVariable
// El actor estaba sumando la energa de los postes en el costo en lugar de la energa
// por el costo de la fuente.


//  vSimSEESimulador = '4.41_fatum_';
//  201406252112

//  vSimSEESimulador = '4.40_garza_';
  // 20140613 bugfix en uFuncionesReales el clculo de la potencia del
  // Panel no estaba topeado al mximo lo que haca que diera diferente
  // segn que la sala fuera horaria o de paso superior pues el tope se
  // aplicaba va la restriccin de caja y entoces actuaba sobre el promedio
  // en el caso de salas de paso de tiempo superior a la hora.

//  vSimSEESimulador = '4.39_garza_';
  // 20140603 bugfix en uSolaPV en fijacin de restriccin de caja de la
  // potencia no tena en cuenta si haba ms de una unidad.

//  vSimSEESimulador = '4.38_garza_';
  //20140520 cambios en formularios de edicin SimRes3 para facilitar entrada

  //  vSimSEESimulador = '4.37_garza_';
  // se agrega que las fichas de parmetros dinmicos se ordenan por FECHA y
  // luego por CAPA de esa forma tendra que ante dos fichas en capas
  // diferenes con la misma fecha (del mismo actor o fuente) prevalecer
  // la ficha de mayor capa.

  // vSimSEESimulador = '4.36_garza_';
  // 1) bug fix en BiomasaEmbalsable. La energa vertida no se inicializaba
  // correctamente al inicio de cada crnica. Esto haca que si al final
  // de una crnica haba vertimiento al inicio de la siguiente se repeta
  // ese valor para la energa vertida.
  // 2) Se agreg tambin que al resolver los bornes de las fuentes de los
  // actores PyCVariable si el borne NO EXISTE tire una excpcin con un
  // mensaje que indica el actor, la fuente y el borne.

  // vSimSEESimulador = '4.35_garza_';
  // rch@201404161514
  // Agrego actor TBiomasaEmbalsable


  //  vSimSEESimulador = '4.34_garza_';
  // rch@20140412
  // Agrego posibilidad de indicar
  // "Imponer todas las potencias iguales" en las hidrulicas de pasada.
  // para un mejor modelado de las mini-hidrulicas en el marco del
  // proyecto ANII-FSE-1-2011-1-6552_ModeladoAutoctonasEnSimSEE.
  // **Bugfix. En THidro de Pasada, el Vertimiento NO estaba valorizado
  // con el costo variable (parmetro puesto en USD/Hm3) en la fila de costo
  // este bug nunca apareci pues nunca se utiliz el modelo de central de pasada
  // con un costo diferente de CERO. En la central de pasada la suma de
  // vertimiento ms turbinado suma el caudal entrante (Aportes propios ms erogados
  // por otras centrales.

  // vSimSEESimulador = '4.33_bandurria_';
  // rch@20140408
  // Correccin en fecha de guarda Sim para SimRes3.

//  vSimSEESimulador = '4.32_bandurria_';
  // rch@20140406
  // Agrego manejo de FuenteDeEscurrimientos en THidroConEmbalse, THidroDePasada y THidroConBombeo
  // Este agregado es para poder utilizar el CEGH de escurrimientos desarrollado en conjunto con el
  // IMFIA para el proyecto ANII-FSE-1-2011-1-6552_ModeladoAutoctonasEnSimSEE.

//  vSimSEESimulador = '4.31_bandurria_';
  // rch@20140403 BUGFIX-IMPORTANTE
  // En la versin 4.24 se introdujo un error en el tratamiento de las BAJAS
  // de unidades. El error actuaba en unidades con factor de dispnibilidad < 0.55
  // si al momento de dar de baja la unidad se encotraba rota por los sorteos de
  // disponibilidad fortuita. Dada la doble condicin de que se encontrase rota
  // al momento de la baja y adems que fuese una mquina con disponibilidad < 0.55
  // el bug no se manifest en las salas de uso comn. En la clase del curso de
  // SimSEE (2014-04-03) se analiz una sala en que se baj a propsito la dispnibilidad
  // de un generador a 0.5 y luego se le dio de baja por 1 da.
  // El bug se manisfest en que a pesar de darlo de baja en algunas crnicas
  // el generador estaba y se despachaba.


//  vSimSEESimulador = '4.30b_martineta_';
      //rch@20140331  versin - beta -
      // Incluye algunos cambios de Enzo trabajando en los escenarios.
      // tambin incluye TRobotHttpPost que introduzco para consulta de pronsticos.

//  vSimSEESimulador = '4.30_martineta_';
      //rch@20140315 Agrego "Soporte a Usuarios" en el Men del Editor.

  //vSimSEESimulador = '4.29_martineta_';
      //rch@20140309 bugfix
      // En ufuncionesReales.pas, en la funcin
      // function TFf_xmult_conselector_vxy.fval( vx, vy: NReal): NReal;
      //
      // que es usada por ParqueEolico_vxy
      // Habia un erro, si vy = 0  antes simplemente pona iang:= 0;
      // esto estaba mal, si la componente NoreteSur era CERO
      // impona viento del Norte cuando lo correcto es viento del Este
      // o del Oeste segn la componente vx
      // El impacto podra ser en aplicar un factor de rendimiento equivocado
      // cuando abs( vy ) < 1E-3.

//  vSimSEESimulador = '4.28_terra_';
  // rch@20140306
  // bugfix. En optimizacin multicore con CAR activada. No estaba intercambiando
  // los histogramas de interpolacin en los robots de los hilos.

  //vSimSEESimulador = '4.27_flecha_';
  // rch@20140216
  //   1) Corrigo bug en function Tf_ddp_Weibull.t_area(area: NReal): NReal;
  // de la unidad fddp.pas.  Este bug haca que las fuentes de Weibull no generaran
  // nmeros con distribucin de Weibull. El bug surge al documentar la fuente
  // y no surgi antes pues no ha sido usada. No afecta ninguna Sala de las comunmente
  // usadas.
  //   2) Se agrega parmetro "Fecha de Guarda" en Simulacin. Esta fecha es usada
  // para ignorar en los archivos de salida todo lo que sucede antes de esa fecha.
  // se agrega como una forma cmoda de independizarse de la condicin inicial.


//  vSimSEESimulador = '4.26_DIENTUDO_';
  // rch@20140102
  // bugfix: TFuenteSelectorHorario no se guardaba bien.

  // vSimSEESimulador = '4.25_DIENTUDO_';
  // rch@20131228
  // bugfix: en procedure THidroConEmbalse.cambioFichaPD;
  // Se corrige que para el clculo de las constantes de la parbola de
  // las funciones CotaToVolumen y VolumenToCota.
  // Tal como estaba supona que el h_min era el punto con volumen cero
  // en la tabla de cotas-volumenes.

  //vSimSEESimulador = '4.24_DIENTUDO_';
  // rch@20131228
  // Cambio el manejo de las disponibilidad fortuita. Ahora el AltaConIncertidumbre
  // se especifica por FIcha y por tipo de Unidad.
  // Tambin agregu InicioCronicaConIncertidumbre por ficha y por unidad.
  // Esto permite indicar si al inicio de cada crnica se debe considerar las unidades
  // fuera de mantenimiento como DISPONIBLES o si de debe introducir incertidumbre sobre
  // el estado inicial haciendo un sorteo para representar las probabilidades de estado
  // estacionario.

//  vSimSEESimulador = '4.23_BOA';
// rch@20131221 Milena agrega modelo de planta solar PV.

//  vSimSEESimulador = '4.22_BAGRE';
// rch@20131207 Federico agrega persistencia de las semillas de Sim y Opt y el tipo
// de optimizacin (PDE o Determinista) a la sala de juego. Yo las agrego al editor.


//  vSimSEESimulador = '4.21_BOGA_';
// rch@20131027 bugfix en THidroConEmbalse y en la activacin de escenarios.
// El error haca que el inicio del control de crecidas quedara incierto
// desde el inicio.

//  vSimSEESimulador = '4.20_BOGA_';
  // rch@20131020 Uniformizo un poco el tratamiento de los PagosPorDisponibilidad
  // y PagoPorEnergia. (no logr uniformizar en todos los actores).
  // Por lo menos se los agregu a los ms usados.

//  vSimSEESimulador = '4.19b_BOGA_';
  // rch@20131018
  // bugfix en editor de curvas velocidad-potencia de los parques elicos.

//  vSimSEESimulador = '4.19_BOGA_';
  // rch@201310152247
  // Cambio tratamiento de datos histricos para que interpole de forma
  // de mantener el promedio.

  //vSimSEESimulador = '4.18_BOGA_';
  // rch@201310141239 - Bugfix. Al agregar los ruidos Wa en la bornera
  // se corri el indexado de los bornes de las fuentes CEGH.

//  vSimSEESimulador = '4.17_BOGA_';
  // rch@201310131216 - Comienzo a introducir Ruida Multi Retardo

//  vSimSEESimulador = '4.16_BOGA_';
// rch@201310121847
// Agrego radio buttons para definir si usar CVaR o VaR en la optimizacin
// con Riesgo.
// -> sigo modificando la versin mh (MultiHilo) buscando porqu da diferente
// que la simple hilo. Al parecer el problema era con los CEGH de ms de un retardo
// con reduccin de estado. El problema estaba en la lectura de la matriz de reduccin
// y en la escritura en formato binario del CEGH.
// Atencin: Sigue sin estar operativa MatrizRuida para CEGHs multi-retardos.

//  vSimSEESimulador = '4.15_BOGA_';
// rch@201310120931
// bugfix, en simulaciones con series histricas de CEGHs haba 2 errores
// 1) El valor de la primer semana se tomara de la crnica
// correspondiente a el nmero de crnica ms la semilla aleatoria (segn una opcin de compilacin)
// pero luego continuaba tomando valores de la crnica asociada al ordinal de la crncia.
// 2) Al anillar las crnicas se repeta la primer crnica dos veces. Este error no afecta
// a la mayora de las corridas pues casi siempre se simula la misma cantidad de crnicas
// que las histricas y por lo tanto la repeticin no apareca.

//  vSimSEESimulador = '4.14_BOGA_';
// cambio la versin multihilo para tener mejor control de los hilos.

//  vSimSEESimulador = '4.13_BOGA_';
// rch@201309302315
// bugfix. Editor de Actores fallaba si al crear un actor se intentaba definir unidades sin antes guardar el actor
// este error se introdujo en la versin 4.07 al definir el checkbox AltaUnidades_Con_Incertidumbre

//  vSimSEESimulador = '4.12_BOGA_';
// rch@20130928
// bugfix: en el editor de enganches de CF haba un error por el cual
// si bien salvaba los enganches al abrir de nuevo el editor los perda
// y volva a poner los valores por defecto.

//  vSimSEESimulador = '4.11_MOJARRITA_';
  //rch@20130925  bugfix. en ploteo de conos de pronsticos. El error
  // fue introducido en la 4.10 y no introduce errores de resultados
  // causaba excepcin al intentar plotear los conos de pronsticos de un CEGH.

//  vSimSEESimulador = '4.10_MOJARRA_';
  //rch@20130921  agrego en CalibrarCono de los CEGH que muetre
  // la trayectoria del estado reducido. Esto es para poder ver
  // el estado en el que hay que enganchar en una semanal horaria
  // con la MP de paso diario pero CEGH semanal.

//  vSimSEESimulador = '4.09_MOJARRA_';
  // rch@20130920 queda andando la ejecucin de escenarios.

//    vSimSEESimulador = '4.08_TARARIRA_';
  // rch@20130917
  // Mejoro margen en control de crecidas.

//  vSimSEESimulador = '4.07_TARARIRA_';
  // rch@20130910
  // Agrego booleana AltaUnidades_CON_INCERTIDUMBRE en los Actores.
  // El comportamiento por defecto es TRUE y significa que cuando la cantidad
  // de unidades del actor AUMENTA (o sea se dan de alta nuevas o salen de man
  // tenimientos programdos. El alta se raliza CON_INCERTIDUMBRE y significa que
  // pasan al estado "rotas" y estarn disponible con la probabilidad dada por
  // la reparacin. Esto es as en los actores que por los parmetros FD y TMR
  // tenga sentido el modelo de FALLA/REPARACION.

//  vSimSEESimulador = '4.06_TARARIRA_';
  // rch@20130824
  // 1) (bugfix_menor)SimSEE_OptSim. La llamada a SimRes3 desde OptSim cambiaba de directorio y luego
  // fallaba la segunda vez por no encontrar el archivo de Plantilla cuando no
  // estaba especificado con la ruta completa. Se corrigi haciendo que vuelva
  // a posicionarse en el directorio de la sala.
  // 2) Se agrega botn Optimizacin Determinista y se comienza a probar la resolucin
  // del problema de despacho determinstico.


//  vSimSEESimulador = '4.04_TARARIRA_';
// Agrego parmetro en las salas ObligarDisponibilidad_1_Opt separando as el
// comporatamiento enter Opt y Sim. Esto es para permitir hacer Optimizaciones
// en las que NO se rompan las mquinas.

//  vSimSEESimulador = '4.03_TARARIRA_';
// Comienzo a introducir forzamientos y habilito que las fechas peudan pornerse
// especificando DateTime (es decir no solo el da, tambin hh:mm:ss
// esto permite hacer que los parmetros dinmicos valgan desde una hora en particular.

// rch@20130816 ... comenzamos a introducir Los Forzamientos .
//  vSimSEESimulador = '4.02_NUTRIA_';
// rch@20130813
// 1) Modificamos con Enzo la forma de estimar la derivada de CF en los bordes de la discretizacin
// Ahora, aproxima primero una parbola con los tres puntos ms prximos al extremo
// y en base a la parbola calcula la derivada hacia el exterior de la discretizacin.
// 2) Se agreg en THidroConEmbalse la posibilidad de iterar en la altura del clculo
// del coeficiente energtico para tener en cuenta variaciones de la cota durante el paso
// de tiempo. Esta opcin se habilita con un conditional define USAR_APRI  (de usar Aproximacin de Integral).
//

//  vSimSEESimulador = '4.01_NUTRIA_';
// rch@20130807
// Modificaciones al Simulador/Optimizador
// agrego Botn LlenarConUltimoFrame en el panel de Optimizacin
// agrego botn Ecualizar y casillero para fijar la cantidad de pasos.
// Es para probar diferentes formas de las prog. semanal.

//  vSimSEESimulador = '4.00_APEREA_';
// rch@20130801
//   mejoro el funcionamiento del Control de Crecida en THidroConEmbalse
//   agregu un parmetro que permite especificar el Caudal a erogar con el
//   control a pleno. Adems, ahora el control tiene en cuenta la duracin
//   del paso de tiempo suavisando las variaciones del lago.

//    vSimSEESimulador = '3.99_CAPINCHO_';
    // rch@20130728
    // Agrego fuente TFuenteSelector_horario para perimitir ejecutar corridas horarias
    // con fuentes de precios semanales con definicin de precios por POSTES mediante
    // la definicin de filtros horarios que seleccionan la fuente y borne adecuado
    // segn la hora de inicio del paso.
    // Tambin acomodo la fijacin de ls PMIN en THidroConEmbalse en el caso de iteraciones
    // para evitar que PMin de despacho infactible por llegar al fondo del lago.

//  vSimSEESimulador = '3.98_AMBROSIA_';
// rch@20130724
  // Corrigo clculo de UtilidadDirectaDelPaso que no se reincializaba a CERO en cada
  // paso y se iba acumulando. Este error no afecta resutados salvo el de esa variable.
  // Al corregir ese error verifico tambin que las utilidades no se consideran en la
  // formacin del costo futuro durante la optimizacin y agrego un CheckBox que sea
  // Restar utilidades de CF que por defecto sea TRUE.


//  vSimSEESimulador = '3.97_AMBROSIA_';
  // rch@20130723

//  vSimSEESimulador = '3.96_PIRINGUNDIN_';
  // rch@20130716
  // Agrego checkboxes en las fichas de parmetros dinmicos de THidroConEmbalse,
  // THidroConBombeo y THidroConEmbalseBinacional para poder deshabilitar el clculo
  // de la evaporacin y del filtrado del lago. Tambin revierto el "alambre" puesto
  // en la 3.94 que se sealizaba con Qa_MuySeco = 0 que no se quera calcular la
  // evaporacin del lago.

  // vSimSEESimulador = '3.95_PIRINGUNDIN_';
  // rch@20130715
  // Corrigo actor uMercadoSpot_Postizado, para que el CostoDirectoDelPaso
  // tenga en cuenta los DeltaExportadores.
  // Tambin agrega publicacin de variables para SimRes3 de Conector de Combustible y
  // Contrato TakeOrPay asociados al modelado de la regasificadora.

  //  vSimSEESimulador = '3.94_CALIBRANDO_';
  // Enzo agreg que si el Qa_MuySeco es CERO entonces no considera Evaporacin.
  // Esto se arregl pues en el caso de Salto Grande, los aportes disponibles
  // ya tienen descontada la evaporacin.

//  vSimSEESimulador = '3.93_CALIBRANDO_';
  // rch@20130618
  // bugfix1: en uevapUruguay.pas, la funcin "InicializarCoeficientesDeEvap"
  //        tena un bug y usaba las tablas de coeficientes de evap, alreves.
  // bugfix2: en uHidroConEmbalse.pas, la funcin "THidroConEmbalse.CotaToSuperficie"
  //         devolva el rea en Hm3/m lo que es 1e-6 del valor en m2.
  //         esto tena como efecto que la evaporacin; que se calcula como un
  //         valor en coeficiente expresado en  m/s multiplicado por el rea
  //         dava valores despreciables. Ahora la funcin retorna el valor en m2 como debe ser.

  // vSimSEESimulador = '3.92c';
  // rch@20130606 agrego en uHidroConEmbalse control de NO Desfondar el Lago con
  // caudales negativos.

//  vSimSEESimulador = '3.92b';
  // rch@20130606 cambio formulario edicin fichas fuentes simples porque no funcionaba
  // bien el scroll cuando se agregan muchas.

//  vSimSEESimulador = '3.92';
// Se implementa ExpansorRuida cuando la reduccin de estado en los CEGH no es completa.

//  vSimSEESimulador = '3.91';
  // rch@20130524 - Cambio operaciones sumaproducto en SimRes3 para que funcionen
  // aunque uno de los ndices no sean postizados. Esto facilita clculos como
  // sumadobleproducto_condurpos para calcular el COSTO de generacin al hacer
  // sumadobleproductocondurpos de las potencias con el CV de la mquina.

//  vSimSEESimulador = '3.90';
  // rch@201305161909
  // Agrego evento prepararPaso_ps en los monitores de la optimizacin.
  // Agrego que al empaquetar se fije si existe archivo con mismo nombre .mon y lo empaquete.

//  vSimSEESimulador = '3.89_UG';
// rch@201305061034
// Se agregan UsosGestionables.
// Bugfix en EMPAQUETAR que no andaba bien con duplicados.


//  vSimSEESimulador = '3.88_CHAOS+++';
// rch@201305011243 - Da de los trabajadores.
// Bugfix en modelo de TArcoConSalidaProgramable que afectaba al Editor.

//  vSimSEESimulador = '3.87_CHAOS++';
// rch@20130423
// corrigo bug en fddp.pas
// function TMadreUniforme.rnd: NReal;
// generaba nmeros que no siempre estaban en entre 0 y 1

//  vSimSEESimulador = '3.86_CHAOS+_GNL_';
// rch@201304111947 bugsfixs
// a) en manejo de la lista de plantillasSimRes3
// b) el modelo ParqueEolico re-publicaba las variables de Potencia.
// -- ninguno de los bugs tiene consecuencias en los resultados --

//       vSimSEESimulador = '3.85_CHAOS+_GNL_';
// corrgimos con AC. sorteos Turbo Vapor en el CC. Revisar actualizacin sorteos.

//     vSimSEESimulador = '3.84_CHAOS_GNL_beta';
     // rch@201303212337
     // 1) corrigo bug en editor de SimRes3 que mezclaba los ndices de las variables.
     // 2) quito mensaje que apareca al intentar editar el cono de pronsticos de un CEGH.
     // ninguno de los cambios afecta resultados. Son solo cuestiones de "edicin".
     // vSimSEESimulador = '3.83_CHAOS_GNL_beta ... no existi.
//    vSimSEESimulador = '3.82_CHAOS_GNL_beta';
    // rch@20130310 le agrego TGTer_ConectableASuministro que calcule el cvm (coso medio para despacho)
    // y lo publique para SimRes3PorDefecto.

//  vSimSEESimulador = '3.81_CHAOS_GNL_beta';
// rch@20130307 bugfix en Simplex. Haba un error que ocasionaba un bucle inifinito
// en la resolucin de igualdades que termina con una excepcin por acceso fuera de
// que se daba en las situaciones en que el Simplex era usado desde un MIPSimplex y
// en condiciones en que en un NODO PADRE resultan redundante restricciones de igualdad.
// Al resolver una rama de ese nodo se produca la condicin.

//  vSimSEESimulador = '3.80_CHAOS_GNL_beta';
  //rch@20130306 Integra fuentes desarrollados por equipo de UTE (F.Ron A.Bouvier) de
  // modelo de la regasificadora en el Simulador - Falta agregar en EDITOR.

//  vSimSEESimulador = '3.79_CHAOS_GNLgamma';
    // rch@20130227 BUGFIX en modelo de uger_onoffporpaso ( en la v3.76 quedo un bug que afectaba el clculo del pago adicional por energa
    // en las onoff por paso. No se inicializaba una variable, con lo cual dependiendo de la suerte, se produca un error de desborde numrico.
//  vSimSEESimulador = '3.78_CHAOS_GNLgamma';
  // comenzamos a agregar actores para modelo de Regasificadora y Suministros de Combustible.
//  vSimSEESimulador = '3.77_CHAOS';
  // Fernanda Maciel &rch@20130225 agrego consideracin de las importaciones en el clculo de los factores de emisiones de CO2
//  vSimSEESimulador = '3.76_CHAOS';
  // rch@20130222 corrigo BUG  en clculo del CDP de las Trmicas con ONOFFPORPASO.
//  vSimSEESimulador = '3.75_CHAOS';
  // rch@20130218 corrigo BUG en Expansion RUIDA. Intentando hacer andar CEGH_peol7p2MWsem1234_mvar
  // todava quedan detalles a arreglar para generalizar el uso de la ExpansinRUIDA.

//  vSimSEESimulador = '3.74_CHAOS';
   // rch@20130216
   // 1) Agrego en algunos actores trmicos el IngresoPorDisponibilidad y IngresoPorEnergia
   // como variables calculadas y publicadas. Habra que genralizarlo a todos los actores.
   // En estos actores el vector "costos" tiene los costos por poste que resultan de los costos operativos
   // considerados para el despacho. Ojo, en versin anterio el vector "costos" inclua los IngresosPorEnergia
   // Este cambio es para separar mejor lo que son costos considerados para el despacho de costos operativos.
   // Hay que pensar como se generaliza esto. Habr que poner el vector Costos y las variables
   // IngresosPorEnergia e IngresoPorPotencia al nivel de TActor para que est en todos.
   // 2) En SimRes2 se produca un error (se colgaba el Excel) si en alguna operacin se ponen
   // nombres para la hoja con caracteres raros y/o nombres demasiados largos.
   // Para evitar esto, se agreg una funcin de "purificacin" de los nombres de las hojas
   // que quita caracteres raros y cambio espacios por "_".



  // vSimSEESimulador = '3.73_CHAOS';
  // rch@201301224 correccin en el editor para despliegue de actores con muchas unidades.
  //  vSimSEESimulador = '3.71_ANARQUIA_GD'; // rch@201301224 mejora en el clculo del factor de emisiones BuildMargin y correccin en el editor del listado con informacin para emisiones.
  //  vSimSEESimulador = '3.70_ANARQUIA_GD'; // rch@20121206 ArcosPostizados y con manejo del peaje en despacho y CDP.

  //  vSimSEESimulador = '3.69_ANARQUIA_EFCM'; // rch@20121203 cambio los arcos para que se pueda especificar
  // PMax, rendimiento y peaje por poste. Esto es necesario para la integracin con Flucar.

  //  vSimSEESimulador = '3.68_ANARQUIA_EFCM'; // rch@20121116 completo Posibilidad de clculo de Factor de Emisiones "Combined Margin".
  // se agrega en el editor el formulario CO2, que permite especificar el clculo.
  // este formulario contiene un despliege de los generadores para poder especificar facilmente
  // los parmetros de los mismos que intervienen en el clculo de las emisiones.
  // Se agreg a los generadores un campo booleano que permite indicar si el mismo est
  // aderido a un CDM (Clean Development Mechanism) para considerarlo o no en el clculo del
  // Build_Margin que luego se utiliza en el calculo del Combined_Margin.

  //  vSimSEESimulador = '3.67_ANARQUIA_EFCM'; // rch@20121110 agrego Posibilidad de clculo de Factor de Emisiones "Combined Margin".
  //   vSimSEESimulador = '3.66_ANARQUIA_CongPosDispo'; // rch@20121019 agrego adems que publicquen la disponibilidad los arcos y de los generadores PyCV

  //  vSimSEESimulador = '3.65_ANARQUIA_CongestinPositiva'; // rch@20121019 cambio costo de congestin. Ahora es SOLO cuando est activa la restriccin del tope.
  // Tal como estaba era la suma de la restriccin del tope y la del piso (P=0) y era confuso.

  //  vSimSEESimulador = '3.64_ANARQUIA_'; // rch@20121015 corrigo bug en editor el [VACIAR] limpiaba el cuadro de texto, pero no las variables de la sala
  // que defnian los archivos de enganche. Esto haca que al empaquetar la sala fallaba por no encontrar el archivo referido.
  // Tambin se acompod el ZIPPER del empaquetar para que pueda zippear archivos que estn abiertos para lectura.
  // Esto haca fallar el empaquetado de salas con "demandas detalladas" pues dichas demandas dejan abierto en archivo
  // de datos en modalidad lectura.

  //  vSimSEESimulador = '3.63_ANARQUIA_'; // rch@20121014 Independizo a todos los Actores y Fuentes ... ahora que cada uno se realice como quiera.
  //  vSimSEESimulador = '3.62_RUIDA_ConSesgosOd_CO2_EnganchesProm_Beta'; // rch@20121008 agrego posibilidad de enganches de CF promediando en las dimensiones desaparecidas
  //  vSimSEESimulador = '3.61_RUIDA_ConSesgosOd_CO2_Beta'; // rch@20121005 Uniformiso vector P en los uninodales = Potencia Inyectada.
  // Esto cambi el comportamiento de las variables exportadas de las demandas (antes era la P pretendida consumir)
  // y ahora es la P Neta (Fallas - Demanda Pretendida) = - Demanda Real
  // Adems de ese cambio (que es para que sea fcil tener las potencias que iran al FLUCAR
  // se agreg en la clase generador TonCO2xMWh (factor de emisiones) y LowCostMustRun (booleana) para facilitar
  // el clculo de factores de emsiones.

  //  vSimSEESimulador = '3.60_RUIDA_ConSesgosOd_Beta'; // rch@20120920 cambio en la lectura para que los nombres de campos ignoren entre maysuclas y minsculas
  // esto facilita la modificacin manual de los archivos de sala.

  //  vSimSEESimulador = '3.59_RUIDA_ConSesgosOd_Beta'; // rch@20120812 agrego que imprima en SimCosto el CFaux y el CT = cdp+CFaux
  //  vSimSEESimulador = '3.58_RUIDA_ConSesgosOd_Beta'; // rch@20120812 bugfix ufechas setAnio en una fecha si justo mes=2 y dia=29
  //rch20120911  vSimSEESimulador = '3.57_RUIDA_ConSesgosOd_Beta'; // rch@20120811  bugfix en sicronizacion de historicos. En determinada condicin
  // en simulaciones horarias con CEGH BPS semanal se tracaba con Excption por una comparacin
  // de fechas mal hecha.
  //  vSimSEESimulador = '3.56_RUIDA_ConSesgosOd_Beta'; // Agrego expansion de sesgos en opt RUIDA->Od
  //  vSimSEESimulador = '3.55_RUIDA_Beta'; // Corrige BUG impresion de reales con Formato
  // y adems se agrega que en los resultados de simulacin "simcosto_SEM_NCRON.xlt" se
  // imprimen los costos directos actualizados y el costo Futuro de final de juego
  // tambin actualizados. Adems de imprimir los costos Totales.
  // Tambin se aegreg que se genera un archivo por crnica en el que los actores
  // con estado escriben su valor de fin de juego. Esto es con el propsito de
  // poder encadenar simulaciones tomando el estado inicial desde el final de otra.

  //  vSimSEESimulador = '3.54_RUIDA_Beta'; // Agrego Expansin RUIDA en modelos CEGH.
  // atencin por ahora aplica solo a los casos en que la reduccin va a 0 ve.
  // por ejemplo caso modelos horarios de viento.
  // Todava no aplica a todos pues me tranqu en resolver la raiz de BaBa cuando
  // es semi-definida positiva.
  //  vSimSEESimulador = '3.53'; // agrego posibilidad de Sincronizar con Datos Histricos.
  //  vSimSEESimulador = '3.52beta'; // rch@20120705 Se corrigen FUENTES dependientes de FUENTES
  // para que calculen sus salidadas den prepeararpaso_ps. Antes por eficiencia durante la
  // optimizacin esto se haca en SortearEntradasdaRB y ValorEsperadoEntradaRB y el mismo
  // procedimiento Sortear se encarga de calcular las salidas. Pero esto ESTABA MAL pues
  // por ejemplo en la fuente producto, si una de las entradas era un CEGH con estado,
  // al ir posicionando la estrellita (luego de los sorteos del paso) se cambia la salida
  // del CEGH, pero no se recalcula el producto posterior. Por simplicitad se cambiaron las fuentes
  // combinacion, producto, sinusoide, maxmin, selector para que calculen sus salidas en
  // prepararpaso_ps. Esto puede ser ineficiente durante el proceso de optimizacin si
  // ninguna de las fuentes de entrada a una fuente de ese tipo tiene estado, pero
  // para optimizar este tema habra que ubicar dentro de las fuentes que dependen de una con
  // estado y ponerlas en una lista de "recalcular en prepararpaso_ps". Por ahora ms vale
  // ineficiente pero ROBUSTO.

  //  vSimSEESimulador = '3.51beta2'; // rch@20120701 Corrigo bug tonto en modalidad NO usar CAR.
  //  vSimSEESimulador = '3.51';
  // rch@20120626 Agrego menejo de la Aversin Al Riesgo en la programacin dinmica estocstica.

  //  vSimSEESimulador = '3.50';
  //rch@20120624 Queda funcionando que los modelos CEGH pueden trabajar con filtro lienal constate (como antes)
  // y adems puede tener el filtro lineal variable al igual que los deformadores.
  // Para generar el CEGH variable.
  // Cambio realizado para proyecto del IMFIA (ANII-FSE-31-2009-Mejoras en la simulacin de aportes a las represas hidroelctricas para su incorporacin a modelos de planificacin energtica)

  //  vSimSEESimulador = '3.49';
  // +agrega: modelo TArcoConSalidaProgramable.
  // +mejora: se cambi el comportamiento de THidroConEmbalse para que si est
  // marcado "Valorizado Manual del Lago" igual mantenga las tablas auxiliares
  // de caudal erogado durante la optimizacin para mejorar la precisin de la
  // estimacin del coeficiente energtico durante la optimizazin aunque no se
  // considere el volumen embalsado como variable de estado.

  //  vSimSEESimulador = '3.48';
  // corrijo interpolacin entre tablas de evaporacin en fuente uevapUruguay.pas.
  // Esta correccin es menor. En la interpolacin entre las dos tablas de evaporacin
  // correspondiente a muy_seco y a muy_humedo haba un error que implicaba un pequeo sesgo
  // hacia la tabla de muy_seco.

  //  vSimSEESimulador = '3.47';
  // Elimino el control de monotona de la derivada introducido enla 3.46.
  // Sencillamente me convenc que la funcin de Costo Futuro no tiene porqu ser convexa
  // respecto del volumen embalsado. Haciendo una optimizacin de un sistema muy sencillo
  // con solo una central don embalse con caudal constante, demanda constante y con un nico
  // recurso en el sistema de costo constante, el mismo volumen de agua sustituye una cantidad
  // de energa mayor a mayor cota, por lo tanto su valor para el futuro es SUPERIOR a conta
  // mayor y esto implica que la funcin de costo futuro es CONCAVA para este ejemplo!!.
  // As que no tiene sentido imponer la monotona del derivada.
  // En el caso ms natural, el sistema tiene muchos recursos y de diferentes valores y
  // por eso resulta natural suponer que si tengo el lago con mayor cota estoy "mejor" y
  // entonces el agua vale menos, pero el contraejemplo anterior es contundente en mostrar
  // que la convexidad de CF no est garantizada.

  //  vSimSEESimulador = '3.46';
  // Agrego control de monotona de la derivada en la HidroConEmbalse.
  // en funciones de costo futuro en las que la derivada Inc se igualaba a la Dec los errores
  // de truncamiento lograban suvertir el orden y eso ocasiona inestabilidad en el algoritmo de
  // programacin dinmica estocstica.

  //  vSimSEESimulador = '3.45';
  // Corrijo chequeo de Turbinado y Bombeo simultaneo
  // en las HidroConBombeo. El chequeo estaba mal pues verificaba la suma de los
  // turbinados y bombeos de los postes, y detectaba como error situaciones
  // en que el bombeo se realiza en un poste y el turbinado en otro.

  //  vSimSEESimulador = '3.44';// Agrego modelo de Banco de Bateras.
  //  vSimSEESimulador = '3.43';// comento lecutra del filtrao de crnica introducido en la v341 todava no est listo
  //  vSimSEESimulador = '3.42';// corrigo bug. Luego de leer un CEGH impongo la cantidad
  // de retardos de los pronsticos igual al del modelo de simulacin.
  // tal como estaban eran independientes y si creaba una sala con un modelo
  // de varios retardos luego aunque cambiara el modelo la cantidad de retardos
  // de los pronsticos segua con la del modelo inicial.

  //  vSimSEESimulador = '3.41';//  rch+20120524 v3.41 agrego filtrado global de crncia en SimRes3 (EN PROCESO)
  //  vSimSEESimulador = '3.40';//  rch+20120426. v3.40
  // Agregu en el clculo del mximo volumen exigible en las restricciones de erogado
  // mnimo que tenga en cuenta adems del volmen embalsado y los aportes, la capacidad
  // de extraer ese volmen mediante turivinado+vertido. Tal como estaba no se haca
  // ese control y en situaciones en que el lago se encuentra por debajo del vertedero
  // si se le peda un erogado por encima del mximo turbinable no lo lograba.
  // Ahora, para determinar si puede cumplir con una condicin de Erogado Mnimo,
  // Limita el volumen de la condicin a no superar ni el volumen
  // embalsado + Aportes - prdidas del paso ni el mximo volumen erogable
  // (turbinado + vertido). En esta versin se agreg el control del volumen erogable.

  //  vSimSEESimulador = '3.39'; // rch@20120419 Se corrige bug en ucalibradorpronosticos.pas. El error afectaba la visualizacin de los conos de pronsticos
  // en el caso de fuentes CEGH con NRetardos > 1. En ese caso se visualizaban los valores en el mundo gaussiano del estado en k-1.
  // y no la salidas en el mundo real en el instante k como deba de ser. Esto no afecta resultados de simulacin, solo lo que se visualizaba
  // en el calibrador.
  //  vSimSEESimulador = '3.38'; // rch@20120414 Recompilo para que cmdsim escriba los resultados detallado de simulacin y no solo el costo
  //  vSimSEESimulador = '3.37'; // rch@20120329 Corrige error en Imprimir Matriz de Datos de SimRes3 que fallaba si se marcaba graficar
  //  vSimSEESimulador = '3.36'; // Se agregaa la fuete aleatoria "selector(A; B, C, D ) donde s

  //  vSimSEESimulador = '3.35'; // Corrige error en la determinacin de la cantidad de aos para simulacin con series histricas.
  //  vSimSEESimulador = '3.34'; // Corrige confusin por BOM en archivos de texto. Por alguna misteriosa razn empezarona aparecer 3 bytes al inicio de los archivos que confunde la lectura de la versin.
  //  vSimSEESimulador = '3.33'; // Corrige bug en Edtior SimRes3 que ocurra al cambiar el actor de un ndice.
  //  vSimSEESimulador = '3.32'; // Corregimos error de lectura de las PrintCronVar_CompararMultiples_cronvar introducido en la v3.31
  //  vSimSEESimulador = '3.31'; // Agrego a SimRes3 PostOperaciones MultiOrdenar y MultiPromedioMovil. Tambin agrego a los PrintCronVars, la posibilidad de
  // de indicar si hacen un Pre_Ordenar (como ya lo hacian) para imprimir resultados probabilsticos o no.
  // Tambin si los resultados probabilsticos son ProbabilidadesDeExcedencia (como hasta ahora) so son ValoresEnRiesgo
  // la diferencia es que en un caso imprime el valor que es exedido con cierta probabilidad pero en el caso de ValorEnRiesgo imprime
  // el promedio de los valores entre los lmites de ProbDeExcedencia.
  //  vSimSEESimulador = '3.30'; // se corrige lector de TFuenteSintetizador para solucionar lectura de version v54
  //    vSimSEESimulador = '3.29'; // cambios en las funciones de fecha para diferenciar entre semanas en base 52 o semanas de 7 das.
  //  vSimSEESimulador = '3.28'; // arreglo tamao de venta exportar actores del editor
  //  vSimSEESimulador = '3.27'; // Cambio sorteo para resumir borneras en esclavizador sub-muestreado a "sorteos delpaso" para que sea independiente del estado
  //  vSimSEESimulador = '3.26'; // manejo de CFAux en editor agrego posibilidad de borrado
  //  vSimSEESimulador = '3.25'; // arreglo error de manejo de CFAux

  //  vSimSEESimulador = '3.24'; //1) agregamos que la semilla aleatori se inicial al principio de cada
  // crnica como semillaInicial+kCronica
  // 2) se corrigi que si se marca "Escribir Archivos Opt Actores" deshabilite la posibilidad de correr multi-hilo

  //    vSimSEESimulador = '3.23'; // Acomdamos orden de graficado en CompararVariables de SimRes3
  //    vSimSEESimulador = '3.22'; // Agregado de botn "Borrar Sesgos" en fuentes CEGH
  //    vSimSEESimulador = '3.21'; // MinHOrasOn y MinHOrasOFF en las Trmica con costo de arranque/parada
  //    vSimSEESimulador = '3.20'; // Actores con varias tipos de unidades
  //  vSimSEESimulador = '3.19 beta'; // Postizado del actor TMercadoSpot.
  //  vSimSEESimulador = '3.18 beta'; // Mejora del clculo de la matrz B de los CEGH.
  vSimSEEEdit_ = vSimSEESimulador_;
  vSimRes3_ = vSimSEESimulador_;
(*
El log de cambio de versiones est en:
http://iie.fing.edu.uy/simsee/ayuda/ayuda.php?hid=versiones&titulo=versiones#

por favor mantener actualizado ese log.
El log debe contener la descripcin del cambio de versin desde el punto
de vista del usuario de la plataforma SimSEE y no el detalle
de los cambios en la programacin (los cuales si son relevantes deben quedar
como comentarios DENTRO DE LOS FUENTES con el formato
autor@FECHA:comentario.
*)

implementation

end.
